VERSION 2.00
Begin Form Form1 
   BackColor       =   &H00C0C0C0&
   Caption         =   "DB Administrator"
   ClientHeight    =   1830
   ClientLeft      =   1695
   ClientTop       =   2505
   ClientWidth     =   4605
   Height          =   2520
   Icon            =   FORM1.FRX:0000
   Left            =   1635
   LinkTopic       =   "Form1"
   ScaleHeight     =   1830
   ScaleWidth      =   4605
   Top             =   1875
   Width           =   4725
   Begin CommonDialog CMDialog1 
      CancelError     =   -1  'True
      Left            =   240
      Top             =   240
   End
   Begin Menu M_Admin 
      Caption         =   "Administration"
      Begin Menu M_DB_repair 
         Caption         =   "Repair DB"
      End
      Begin Menu M_DB_compress 
         Caption         =   "Compress DB"
      End
      Begin Menu M_DB_Backup 
         Caption         =   "Save/Load"
         Begin Menu M_DBBackup 
            Caption         =   "Backup"
         End
         Begin Menu M_DBRestore 
            Caption         =   "Restore"
         End
      End
      Begin Menu M_DBs1 
         Caption         =   "-"
      End
      Begin Menu M_DBEnd 
         Caption         =   "End"
      End
   End
   Begin Menu M_Help 
      Caption         =   "Help"
      Begin Menu M_HInhalt 
         Caption         =   "Contents"
      End
   End
End
Declare Function WinHelp Lib "User" (ByVal hWnd As Integer, ByVal lpHelpFile As String, ByVal wCommand As Integer, dwData As Any) As Integer
Dim MyDB As String

Sub Form_Load ()
    app.HelpFile = app.Path + "\db_adm.hlp"
    If Command = "" Then
	MyDB = "*"
    Else
	MyDB = Command
    End If
End Sub

Function GetFileName (ByVal InString As String) As String
	laenge% = Len(InString)
	i% = laenge%
	MyChar$ = Mid(InString, i%, 1)
	While MyChar$ <> "\" And i% > 1
	   i% = i% - 1
	    MyChar$ = Mid(InString, i%, 1)
	Wend
	GetFileName = Mid(InString, i% + 1, InStr(i% + 1, InString, ".") - i% - 1)
End Function

Function GetPath (ByVal InString As String) As String
	laenge% = Len(InString)
	i% = laenge%
	MyChar$ = Mid(InString, i%, 1)
	While MyChar$ <> "\" And i% > 1
	   i% = i% - 1
	    MyChar$ = Mid(InString, i%, 1)
	Wend
	If i% > 1 Then
	    GetPath = Left(InString, i%)
	Else
	    GetPath = ""
	End If
End Function

Sub M_DB_compress_Click ()
    On Error GoTo DC2
    CMDialog1.Filename = MyDB + ".mdb"
    CMDialog1.Action = 1
    On Error GoTo 0
    
    If CMDialog1.Filename <> "" And CMDialog1.Filename <> "*.mdb" Then
	
	Load TheMsg
	TheMsg.Caption = "Compress DB"
	TheMsg.L_Msg.Caption = "Please wait..."
	
	TheMsg.Show
	ret% = DoEvents()
	'----> first, make a copy
	TargetPath$ = GetPath(CMDialog1.Filename)
	TargetFileName$ = GetFileName(CMDialog1.Filename)
	SourceFileName$ = TargetFileName$
	If Len(TargetFileName$) < 6 Then
	    TargetFileName$ = TargetFileName$ + "NEW"
	Else
	    TargetFileName$ = Left(TargetFileName$, 5) + "NEW"
	End If
	'now create backup copies
	On Error Resume Next
	Kill TargetPath$ + TargetFileName$ + ".MDB"
	On Error GoTo MDBCE1
	CompactDatabase CMDialog1.Filename, TargetPath$ + TargetFileName$ + ".MDB"
	On Error Resume Next
	Kill TargetPath$ + TargetSourceName$ + ".BAK"
MDBCE3:
	Name CMDialog1.Filename As TargetPath$ + SourceFileName$ + ".BAK"
	Kill CMDialog1.Filename
	Name TargetPath$ + TargetFileName$ + ".MDB" As CMDialog1.Filename
	TheMsg.Hide
	Unload TheMsg
    End If
    
    GoTo MDBCE2
MDBCE1:
    Select Case Err
	Case 53
	    Resume MDBCE3
	Case 58 'File aready exists
	    MsgBox ("Datei existiert bereits")
	    Resume MDBCE2
	Case Else
	    MsgBox ("Error compressing DB " + Format(Err))
	    Resume MDBCE2
    End Select
DC2:
    MsgBox "Error!!!! Number: " + Format(Err)
    Resume MDBCE2

MDBCE2:
    Unload TheMsg

End Sub

Sub M_DB_repair_Click ()
    On Error GoTo DC1
    CMDialog1.Filename = MyDB + ".mdb"
    CMDialog1.Action = 1
    On Error GoTo 0
    If CMDialog1.Filename <> "" And CMDialog1.Filename <> "*.mdb" Then
	On Error GoTo MDBRE1
	Load TheMsg
	TheMsg.Caption = "Repairing DB"
	TheMsg.L_Msg.Caption = "Please wait..."
	TheMsg.Show
	ret% = DoEvents()
	RepairDatabase (CMDialog1.Filename)
	TheMsg.Hide
	Unload TheMsg
    End If
    
    GoTo MDBRE2
MDBRE1:
    MsgBox ("Error repairing DB" + Format(Err))
    Resume MDBRE2
DC1:
    Resume MDBRE2

MDBRE2:
    Unload TheMsg
End Sub

Sub M_DBBackup_Click ()
    On Error GoTo DC3
    CMDialog1.Filename = MyDB + ".mdb"
    CMDialog1.Action = 1
    On Error GoTo 0
    If CMDialog1.Filename <> "" And CMDialog1.Filename <> "*.mdb" Then
	On Error GoTo MDBBE1
	Load TheMsg
	TheMsg.Caption = "Backup DB"
	TheMsg.L_Msg.Caption = "Please wait..."
	TheMsg.Show
	ret% = DoEvents()
	'---->
	TargetPath$ = GetPath(CMDialog1.Filename)
	TargetFileName$ = GetFileName(CMDialog1.Filename)
	SourceFileName$ = TargetFileName$
	'----> Now create backup file
	Kill TargetPath$ + TargetFileName$ + ".BAK"
MDBBE3:
	FileCopy CMDialog1.Filename, TargetPath$ + TargetFileName$ + ".BAK"
	TheMsg.Hide
	Unload TheMsg
    End If
    
    GoTo MDBBE2
MDBBE1:
    Select Case Err
	Case 53
	    Resume MDBBE3
	Case Else
	    MsgBox ("Error saving DB " + Format(Err))
	    Resume MDBBE2
    End Select
DC3:
    Resume MDBBE2

MDBBE2:
    Unload TheMsg

End Sub

Sub M_DBEnd_Click ()
    Const HELP_QUIT = &H2
    R% = WinHelp(form1.hWnd, app.Path + "\db_adm.hlp", HELP_QUIT, 0)
    End
End Sub

Sub M_DBRestore_Click ()
    On Error GoTo DC4
    CMDialog1.Filename = MyDB + ".bak"
    CMDialog1.Action = 1
    On Error GoTo 0
    If CMDialog1.Filename <> "" And CMDialog1.Filename <> "*.mdb" Then
	On Error GoTo MDBRES1
	Load TheMsg
	TheMsg.Caption = "Restore DB"
	TheMsg.L_Msg.Caption = "Please wait...."
	'wait (1)
	TheMsg.Show
	ret% = DoEvents()
	'---->
	TargetPath$ = GetPath(CMDialog1.Filename)
	TargetFileName$ = GetFileName(CMDialog1.Filename)
	SourceFileName$ = TargetFileName$
	Kill TargetPath$ + TargetFileName$ + ".MDB"
MDBRES3:
	FileCopy CMDialog1.Filename, TargetPath$ + TargetFileName$ + ".MDB"
	TheMsg.Hide
	Unload TheMsg
    End If
    
    GoTo MDBRES2
MDBRES1:
    Select Case Err
	Case 53
	    Resume MDBRES3
	Case 70
	    MsgBox "Access on " + TargetPath$ + TargetFileName$ + ".MDB" + " denied"
	    Resume MDBRES2

	Case Else
	    MsgBox ("Backup error  " + Format(Err))
	    Resume MDBRES2
    End Select
DC4:
    Resume MDBRES2
MDBRES2:
    Unload TheMsg

End Sub

Sub M_HInhalt_Click ()
    Const HELP_CONTENTS = &H3
    CMDialog1.HelpFile = app.Path + "\db_adm.hlp"    ' Specify the Help file to open.
    CMDialog1.HelpCommand = HELP_CONTENTS    ' When WINHELP.EXE is executed, Help for a specified keyword will be displayed.
    CMDialog1.Action = 6    ' Execute WINHELP.EXE.

End Sub

